######################################################################
# Make applications library for c-tree application library
# Invoke with MAKEAPPX.BAT
#
# For NET BIOS server version.
#
######################################################################


##################
# default macros #
##################

# rtree directory
RTREE=..\..\rtree

# c compiler
COMPILER=cl /c

# assembler
ASM=masm

# c compiler model switch
CM=/AS

# assemble model define
AM=SMALL

# obj/exe/lib directory
D=SAPP

#c compile include path
P=/I .\ /I ..\ /I ..\msc /I $(RTREE)

#linker name
LINK=link

#library names
LN=ctalib

#OS/2 V1.1
#OSLIB=OS2
#OSNETAPI=netapi+netoem
#OS/2 V1.0
OSLIB=DOSCALLS
OSNETAPI=nampipes+netapi+netoem

#full library name
ALIB=$(LN).lib
ALIBS=$(LN)+$(RUNT)+$(OSLIB)+$(OSNETAPI)

#linker object file list
MSG=+ctamsg+ctapip+ctdosc+ctnetc/m

#make exe's dependency list
DMSG=$(D)\ctamsg.obj $(D)\ctapip.obj $(D)\ctdosc.obj $(D)\ctnetc.obj

################################
# complile all library modules #
################################

# library modules

$(D)\ctappx.obj: ..\ctappx.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctapx2.obj: ..\ctapx2.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctapx3.obj: ..\ctapx3.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctapx4.obj: ..\ctapx4.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctsset.obj: ..\ctsset.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctisam.obj: ..\ctisam.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctvrec.obj: ..\ctvrec.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctvrcu.obj: ..\ctvrcu.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctism2.obj: ..\ctism2.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctismc.obj: ..\ctismc.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctismo.obj: ..\ctismo.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\cticre.obj: ..\cticre.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctiopn.obj: ..\ctiopn.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctcomp.obj: ..\ctcomp.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\cticls.obj: ..\cticls.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctifil.obj: ..\ctifil.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctismu.obj: ..\ctismu.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctestm.obj: ..\ctestm.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctclb2.obj: ..\ctclb2.c    # low level disk interface
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c


#####################
# build the library #
#####################

$(D)\$(ALIB): $(D)\ctappx.obj $(D)\ctapx2.obj $(D)\ctapx3.obj $(D)\ctapx4.obj \
			$(D)\ctsset.obj $(D)\ctisam.obj $(D)\ctvrec.obj \
			$(D)\ctvrcu.obj $(D)\ctism2.obj \
			$(D)\ctismc.obj $(D)\ctismo.obj $(D)\cticre.obj \
			$(D)\ctiopn.obj $(D)\ctcomp.obj \
			$(D)\cticls.obj $(D)\ctifil.obj \
			$(D)\ctismu.obj $(D)\ctestm.obj $(D)\ctclb2.obj
	cd $(D)
	if exist $(LN).bak del $(LN).bak
	if exist $(ALIB) ren $(ALIB) $(LN).bak
	echo $(ALIB) > lrsp
	echo y >> lrsp
	echo +ctappx+ctapx2 ^& >> lrsp
	echo +ctsset+ctisam+ctvrec+ctvrcu+ctism2 ^& >> lrsp
	echo +ctismc+ctismo+cticre ^& >> lrsp
	echo +ctiopn+ctcomp ^& >> lrsp
	echo +cticls+ctifil ^& >> lrsp
	echo +ctismu+ctapx3+ctapx4 ^& >> lrsp
	echo +ctestm+ctclb2 >> lrsp
	echo $(LN).m >> lrsp
	echo $(ALIB) >> lrsp
	lib @lrsp
	del lrsp
	cd ..

#######################################
# compile environment dependent files #
#######################################

$(D)\ctamsg.obj: ctamsg.c 
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) $*.c

$(D)\ctapip.obj: ctapip.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) $*.c

$(D)\ctnetc.obj: ctnetc.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) $*.c

$(D)\ctdosc.obj: ctdosc.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) $*.c

####################################
# compile/link server stop utility #
# CTSTOP                           #
####################################

$(D)\ctstop.obj: ..\ctstop.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctstop.exe: $(D)\ctstop.obj $(DMSG) $(D)\ctclb2.obj
	cd $(D)
	$(LINK) ctstop$(MSG)+ctclb2,,,$(RUNT)+$(OSLIB)+$(OSNETAPI);
	cd ..

####################################
# compile/link server stat utility #
# CTSTAT                           #
####################################

$(D)\ctstat.obj: ..\ctstat.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctstat.exe: $(D)\ctstat.obj $(DMSG) $(D)\ctclb2.obj
	cd $(D)
	$(LINK) ctstat$(MSG)+ctclb2,,,$(RUNT)+$(OSLIB)+$(OSNETAPI);
	cd ..

###################################
# compile/link example programs   #
# CTEXMC CTEXMG CTVXMG CTIXMG     #
###################################

$(D)\ctexmc.obj: ..\ctexmc.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctexmc.exe: $(D)\ctexmc.obj $(DMSG) $(D)\$(ALIB)
	cd $(D)
	$(LINK) ctexmc$(MSG),,,$(ALIBS);
	cd ..

$(D)\ctexmg.obj: ..\ctexmg.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctexmg.exe: $(D)\ctexmg.obj $(DMSG) $(D)\$(ALIB)
	cd $(D)
	$(LINK) ctexmg$(MSG),,,$(ALIBS);
	cd ..

$(D)\ctvxmg.obj: ..\ctvxmg.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctvxmg.exe: $(D)\ctvxmg.obj $(DMSG) $(D)\$(ALIB)
	cd $(D)
	$(LINK) ctvxmg$(MSG),,,$(ALIBS);
	cd ..

$(D)\ctixmg.obj: ..\ctixmg.c
	$(COMPILER) $(P) /Fo$(D)\$*.obj $(CM) ..\$*.c

$(D)\ctixmg.exe: $(D)\ctixmg.obj $(DMSG) $(D)\$(ALIB)
	cd $(D)
	$(LINK) ctixmg$(MSG),,,$(ALIBS);
	cd ..
